@echo off
::
:: Usage:  BackupLibronix %1 [LDLS path] [[-u] Userfiles]
:: %1 is the backup folder eg. F:\logosbackup
:: [LDLS path] is the installation path
:: [userfiles] will force User Files to a non-default location.
:: -u (or -U) is required if User Files is the only parameter.
:: Quotes are required if a path name has spaces eg. "D:\DLS User"
::
:: Windows XP/2k and Vista/Win7
:: D. Hooton February 2009
::

set pFile=%1
If %1!==! goto MISSING
echo %1 | Find "\\" > nul
If %ErrorLevel% EQU 0 echo Finding backup folder on network...
If not EXIST %1 (
   mkdir %1
   If ErrorLevel 1 echo. & goto MISSING
)
echo.
echo Backup folder is %1
echo.

:: Get path variables from GetPaths, but they
:: can be over-ridden from the command line.

Call GetPaths -a
set COMMON=%Libronix%\Common
set LICENCES=%ALLUSERS%\Library\Licenses

If %2!==! goto CHECK
If /i %2 NEQ -u (
   set COMMON=%~2\Common
) else (
   If %3!==! (
      set pFile=%3 & goto MISSING
   )
)
If %3!==! goto CHECK
If /i %3==-u (
    set pFile=%4
    set USERFILE=%~4
) else (
    set pFile=%3
    set USERFILE=%~3
)
If %pFile%!==! goto MISSING
If not EXIST "%USERFILE%" goto MISSING

:CHECK
set pFile="%COMMON%"
If not EXIST "%COMMON%" goto MISSING

:BACKUP
rem /MIR + /COPY:DT = clone files & folders except file attributes
rem /FFT = 2 sec file time tolerance, /DST = allow for Daylight Saving
rem /DCOPY:T = copy folder timestamps

If %Vista%==1 (
   set "DST=/DST"
   set "FTIME=/DCOPY:T"
) else (
   set "DST="
   set "FTIME="
)
echo.
echo Copying Licence Files from %LICENCES%...
ROBOCOPY "%LICENCES%" %1\Licences  /MIR /COPY:DT /NP /NJH /NDL /NFL /FFT %DST%
echo.
echo.

echo.
echo Copying Common Files from %COMMON%...
ROBOCOPY  "%COMMON%" %1\Common  /MIR /COPY:DT /NP /NJH /NDL /NFL /FFT %DST% %FTIME%
echo.
echo.

echo.
echo Copying Preferences from %PREFS%...
ROBOCOPY "%PREFS%" %1\Prefs  /MIR /COPY:DT /NP /NJH /NDL /NFL /FFT %DST%
echo.
echo.

echo.
echo Copying User Files from %USERFILE%...
ROBOCOPY "%USERFILE%" %1\User  /MIR /COPY:DT /NP /NJH /NDL /NFL /FFT %DST%
echo.
echo.

If not EXIST "%MyDocuments%\Libronix Resources" goto AutoX
echo.
echo Copying Sermon Files from %MyDocuments%\Libronix Resources...
ROBOCOPY "%MyDocuments%\Libronix Resources" %1\Sermon  /MIR /COPY:DT /NP /NJH /NDL /NFL /FFT %DST%
echo.
echo.

:AutoX
If not EXIST "%MyDocuments%\AutomatingX" (
   RMDir /S /Q %1\AutoX 2>nul
   goto EXIT)
echo.
echo Copying AutomatingX from %MyDocuments%\AutomatingX...
ROBOCOPY "%MyDocuments%\AutomatingX" %1\AutoX  /MIR /COPY:DT /NP /NJH /NDL /NFL /FFT %DST%
echo.
echo.

goto EXIT


:MISSING
echo.
If %pFile%!==! (
   echo ERROR: Invalid or no folder name
) else (
   echo ERROR: %pFile% cannot be found or is invalid
)

:EXIT
echo.
echo Press any key ...
PAUSE >nul
